/*
 *  Weka4WSFactoryService.java
 *  Copyright (C) 2005 University of Calabria
 *  Dept. of Electronics, Computer Science and Systems
 */

package weka4ws.service.impl;

import java.net.URL;

import org.apache.axis.MessageContext;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.globus.wsrf.ResourceContext;
import org.globus.wsrf.ResourceKey;
import org.globus.wsrf.container.ServiceHost;
import org.globus.wsrf.utils.AddressingUtils;

import weka4ws.stubs.factory.CreateResource;
import weka4ws.stubs.factory.CreateResourceResponse;

/**
 * @author <a href="mailto:mlackovic@deis.unical.it">Marco Lackovic</a> 
 */
public class Weka4WSFactoryService {

    public CreateResourceResponse createResource(CreateResource request)
            throws Exception {
        ResourceContext ctx = ResourceContext.getResourceContext();
        Weka4WSResourceHome home = (Weka4WSResourceHome) ctx.getResourceHome();
        ResourceKey key = home.create();

        URL baseURL = ServiceHost.getBaseURL();
        String instanceService = (String) MessageContext.getCurrentContext()
                .getService().getOption("instance");
        String instanceURI = baseURL.toString() + instanceService;
        EndpointReferenceType epr = AddressingUtils.createEndpointReference(
                instanceURI, key);

        CreateResourceResponse response = new CreateResourceResponse();
        response.setEndpointReference(epr);
        return response;
    }

}
