/*
 *  Weka4WSResource.java
 *  Copyright (C) 2005 University of Calabria
 *  Dept. of Electronics, Computer Science and Systems
 */

package weka4ws.service.impl;

import org.globus.wsrf.ResourceIdentifier;
import org.globus.wsrf.ResourceProperties;
import org.globus.wsrf.ResourceProperty;
import org.globus.wsrf.ResourcePropertySet;
import org.globus.wsrf.Topic;
import org.globus.wsrf.TopicList;
import org.globus.wsrf.TopicListAccessor;
import org.globus.wsrf.impl.ResourcePropertyTopic;
import org.globus.wsrf.impl.SimpleResourceProperty;
import org.globus.wsrf.impl.SimpleResourcePropertySet;
import org.globus.wsrf.impl.SimpleTopicList;

import weka4ws.stubs.service.Result;

/**
 * @author <a href="mailto:mlackovic@deis.unical.it">Marco Lackovic</a>
 */
public class Weka4WSResource implements org.globus.wsrf.Resource,
        ResourceIdentifier, ResourceProperties, TopicListAccessor {

    /*  Resource Property set */

    private ResourcePropertySet propSet;

    private Object key; // resource key

    //  Resource properties

    private ResourceProperty resultRP;

    private TopicList topicList;

    public Object initialize() throws Exception {
        this.key = new Integer(hashCode());
        this.propSet = new SimpleResourcePropertySet(
                Weka4WSQNames.RESULT_RESOURCE_PROPERTIES);
        try {
            resultRP = new SimpleResourceProperty(Weka4WSQNames.RP_RESULT);
            resultRP.add(new Result());
        } catch (Exception e) {
            throw new RuntimeException(e.getMessage());
        }

        this.topicList = new SimpleTopicList(this);

        resultRP = new ResourcePropertyTopic(resultRP);

        ((ResourcePropertyTopic) resultRP).setSendOldValue(true);

        this.topicList.addTopic((Topic) resultRP);

        this.propSet.add(resultRP);

        return key;
    }

    /*  Getters and setters for the RPs */

    public Result getResult() {
        return (Result) resultRP.get(0);
    }

    public void setResult(Result x) {
        resultRP.set(0, x);
    }

    // required by the ResourceProperties interface
    public ResourcePropertySet getResourcePropertySet() {
        return this.propSet;
    }

    // required by the ResourceIdentifier interface
    public Object getID() {
        return this.key;
    }

    //  required by the TopicListAccessor interface
    public TopicList getTopicList() {
        return topicList;
    }

}
